Public Module Sample
    Public Function ProcessFntFile(ByVal sFNTFile As System.String) _
                                  As System.Collections.Generic.List(Of System.Drawing.Bitmap)
        If sFNTFile = "" Then
            Return Nothing
            Exit Function
        Else
            If Not System.IO.File.Exists(sFNTFile) Then
                Return Nothing
                Exit Function
            End If
        End If
        Dim lstResults As New System.Collections.Generic.List(Of System.Drawing.Bitmap)
        Dim lstChars As New System.Collections.Generic.List(Of System.Byte(,))
        'Build a 16 colors MS DOS PC ANSI colors palette
        Dim pal As System.Drawing.Imaging.ColorPalette = BuildMSDOSAnsiColorsPalette()
        Dim bteFC As System.Byte = 7
        Dim bteBC As System.Byte = 0
        Dim fntBytes() As Byte = System.IO.File.ReadAllBytes(sFNTFile)
        Dim lngCurrPos As System.Int64 = 0
        Dim intCharWidth As System.Int32 = 0
        Dim intCharHeight As System.Int32 = 0
        Dim intNumChars As System.Int32 = 0
        intCharWidth = GetWordLE(fntBytes, lngCurrPos)
        intCharHeight = GetWordLE(fntBytes, lngCurrPos)
        intNumChars = GetWordLE(fntBytes, lngCurrPos)
        'Read all character information into a structered array
        'Dimension 1 contains all lines/rows and Dimension 2 the row details (point bits)
        For i As System.Int32 = 0 To intNumChars - 1
            Dim aChar(intCharHeight - 1, intCharWidth / 8 - 1) As System.Byte
            For y As System.Int32 = 0 To intCharHeight - 1
                For x As System.Int32 = 0 To intCharWidth / 8 - 1
                    aChar(y, x) = GetByte(fntBytes, lngCurrPos)
                Next
            Next
            lstChars.Add(aChar)
        Next
        For i As System.Int32 = 0 To lstChars.Count - 1
            Dim Img As New System.Drawing.Bitmap(intCharWidth, intCharHeight, _
                                        System.Drawing.Imaging.PixelFormat.Format4bppIndexed)
            Img.Palette = pal
            Dim bmpSr As System.Drawing.Imaging.BitmapData = Img.LockBits( _
                       New System.Drawing.Rectangle(0, 0, Img.Width, Img.Height), _
                       System.Drawing.Imaging.ImageLockMode.ReadWrite, _
                       Img.PixelFormat)
            Dim ptrSr As System.IntPtr = bmpSr.Scan0
            Dim bytesSr As System.Int32 = bmpSr.Stride * Img.Height
            Dim rgbvaluesSr(bytesSr) As System.Byte
            System.Runtime.InteropServices.Marshal.Copy(ptrSr, rgbvaluesSr, 0, bytesSr)
            Dim iPos As System.Int64 = 0
            Dim xOff As System.Int32 = 0
            Dim yOff As System.Int32 = 0
            For y As System.Int32 = 0 To intCharHeight - 1
                For x As System.Int32 = 0 To intCharWidth - 1
                    Dim arrPos As System.Int32 = Math.Floor((y * bmpSr.Stride) + (x / 2))
                    Dim cb As System.Int32 = Math.Floor(x / 8)
                    Dim bitpos As System.Byte = 8 - (x - cb * 8)
                    Dim wByte As System.Byte = rgbvaluesSr(arrPos)
                    If x Mod 2 <> 0 Then
                        'odd .. right part
                        rgbvaluesSr(arrPos) = (wByte - ((wByte << &H4) >> &H4)) + _
                                       IIf(ExamineBit(lstChars.Item(i)(y, cb), bitpos), bteFC, bteBC)
                    Else
                        'even .. left part
                        rgbvaluesSr(arrPos) = (wByte - ((wByte >> &H4) * 16)) + _
                                      (IIf(ExamineBit(lstChars.Item(i)(y, cb), bitpos), bteFC, bteBC) * 16)
                    End If

                Next
            Next
            System.Runtime.InteropServices.Marshal.Copy(rgbvaluesSr, 0, ptrSr, bytesSr)
            Img.UnlockBits(bmpSr)
            bmpSr = Nothing
            rgbvaluesSr = Nothing
            lstResults.Add(Img.Clone)
            Img.Dispose()
            Img = Nothing
        Next
        Return lstResults
    End Function

    ' The ExamineBit function will return True or False
    ' depending on the value of the 1 based, nth bit (MyBit)
    ' of an integer (MyByte).
    Public Function ExamineBit(ByVal MyByte As System.Byte, ByVal MyBit As System.Byte) _
	                         As System.Boolean
        Dim BitMask As System.Int16
        MyByte = MyByte And &HFF
        BitMask = 2 ^ (MyBit - 1)
        Return ((MyByte And BitMask) > 0)
    End Function

    ' The SetBit Sub will set the 1 based, nth bit
    ' (MyBit) of an integer (MyByte).
    Public Sub SetBit(ByRef MyByte As System.Byte, ByVal MyBit As System.Byte)
        Dim BitMask As System.Int16
        MyByte = MyByte And &HFF
        BitMask = 2 ^ (MyBit - 1)
        MyByte = MyByte Or BitMask
    End Sub

    Public Function GetByte(ByVal arr() As System.Byte, ByRef lngPos As System.Int64) _
                            As System.Byte
        'Read a single byte from a byte array at specified position
        If lngPos < arr.Length Then
            lngPos += 1
            Return arr(lngPos - 1)
        Else
            Return 0
        End If
    End Function
    Public Function GetWordLE(ByVal arr() As System.Byte, ByRef lngPos As System.Int64) _
	                       As System.UInt16
        'read 2 bytes into an unsigned 16 bit integer little endian
        If lngPos + 1 < arr.Length Then
            Return GetByte(arr, lngPos) + (GetByte(arr, lngPos) * 256)
        Else
            Return 0
        End If
    End Function

    Public Function BuildMSDOSAnsiColorsPalette() As System.Drawing.Imaging.ColorPalette
        Dim tmpImg As New System.Drawing.Bitmap(1, 1, _
                          System.Drawing.Imaging.PixelFormat.Format4bppIndexed)
        Dim pal As System.Drawing.Imaging.ColorPalette = tmpImg.Palette
        pal.Entries(0) = System.Drawing.Color.FromArgb(255, 0, 0, 0)
        pal.Entries(1) = System.Drawing.Color.FromArgb(255, 0, 0, 170)
        pal.Entries(2) = System.Drawing.Color.FromArgb(255, 0, 170, 0)
        pal.Entries(3) = System.Drawing.Color.FromArgb(255, 0, 170, 170)
        pal.Entries(4) = System.Drawing.Color.FromArgb(255, 170, 0, 0)
        pal.Entries(5) = System.Drawing.Color.FromArgb(255, 170, 0, 170)
        pal.Entries(6) = System.Drawing.Color.FromArgb(255, 170, 85, 0)
        pal.Entries(7) = System.Drawing.Color.FromArgb(255, 170, 170, 170)
        pal.Entries(8) = System.Drawing.Color.FromArgb(255, 85, 85, 85)
        pal.Entries(9) = System.Drawing.Color.FromArgb(255, 85, 85, 255)
        pal.Entries(10) = System.Drawing.Color.FromArgb(255, 85, 255, 85)
        pal.Entries(11) = System.Drawing.Color.FromArgb(255, 85, 255, 255)
        pal.Entries(12) = System.Drawing.Color.FromArgb(255, 255, 85, 85)
        pal.Entries(13) = System.Drawing.Color.FromArgb(255, 255, 85, 255)
        pal.Entries(14) = System.Drawing.Color.FromArgb(255, 255, 255, 85)
        pal.Entries(15) = System.Drawing.Color.FromArgb(255, 255, 255, 255)
        tmpImg.Dispose()
        tmpImg = Nothing
        Return pal
    End Function

End Module
	